from dataclasses import dataclass


@dataclass  # decorador para a classe estudante
class Estudante:
    nome: str
    RA: int
    curso: int
    notas: list[float]

    @property
    def media(self):
        return sum(self.nota) / len(self.notas)

    def aprovado(self):
        return self.media >= 5.0


class EstudanteDePos(Estudante):

    def __init__(self, nome, RA, curso, notas, orientador):
        super().__init__(nome, RA, curso, notas)
        self.orientador = orientador
    
    @property
    def conceito(self):
        if self.media >= 8.5:
            return 'A'
        elif self.media >= 7.0:
            return 'B'
        elif self.media >= 5.0:
            return 'C'
        else:
            return 'D'
    
    def __str__(self):
        return f'Nome: {self.nome} - Orientador: {self.orientador} - Conceito: {self.conceito}'






# ana = Estudante(nome="Ana", RA=123456, curso=42, nota=10.0)
# print(ana)
